#include <stdint.h>

// Test to run
#define TEST 1

struct message {
    uint8_t type;
    uint8_t data[11];
};

enum TYPES {
    TYPE1 = 1,
    TYPE2
};

struct type1 {
    uint32_t data1;
    uint16_t data2;
};

struct type2 {
    uint8_t length;
    uint8_t data[10];
};

union data_type {
    struct type1 t1;
    struct type2 t2;
};

struct message_union {
    uint8_t type;
    union data_type data;
};

struct __attribute__((__packed__)) message_union_packed {
    uint8_t type;
    union data_type data;
};

void main()
{
    union data_type dt;
    dt.t2.length = 1;
    dt.t2.data[0] = 42;

    struct message msg;
    msg.type = TYPE2;

    union data_type *msg_data = (union data_type *) msg.data;
#if TEST == 1
    *msg_data = dt; //< DATA ABORT! (STMEA)
#elif TEST == 2
    dt = *msg_data; //< DATA ABORT! (LDMFD)
#elif TEST == 3
    memcpy(&dt, (uint8_t*)msg_data, sizeof(union data_type)); //< uses memcpy, no data abort
    memcpy(&dt, msg_data, sizeof(union data_type)); //< uses LDMFD and STMEA, DATA ABORT!
#elif TEST == 4
    struct type2 t2;
    t2 = msg_data->t2; // calls memcpy, no data abort
    struct type2 *msg_type2 = (struct type2 *)msg_data;
    t2 = *msg_type2; // calls memcpy, no data abort
#elif TEST == 5
    struct message_union msg_u;
    msg_u.data = dt;
    struct message_union_packed msg_up;
    msg_up.data = dt;
#endif

    for(;;) ;
}

